﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Events;
using Valve.VR;

public class ClickEventsHelper : MonoBehaviour
{
    public UnityEvent OnClicked;

    void Update()
    {
        if (Input.GetMouseButtonDown(0))
        {
            var mouseRay = camera.ScreenPointToRay(Input.mousePosition);
            RaycastHit hitInfo;
            Physics.Raycast(mouseRay, out hitInfo);
            if (hitInfo.collider != null && hitInfo.collider.transform.IsChildOf(this.transform))
            {
                this.OnClicked.Invoke();
            }
        }
    }


    static Camera _camera;
    static Camera camera
    {
        get
        {
            if (_camera == null)
            {
                int i = 0;
                foreach (Camera cam in GameObject.FindObjectsOfType<Camera>())
                {
                    if (cam.tag == "MainCamera" && (_camera == null || cam.gameObject.GetComponent<SteamVR_Fade>() != null))
                    {
                        _camera = cam;
                    }
                    i++;
                    if (i == 2)
                    {
                        Debug.LogError("There are multiple cameras in the scene.  JsMouseEvent3D may not work.  Please remove Main Camera if you are using SteamVR.");
                    }
                }
            }
            return _camera;
        }
    }
}
